#include <stdlib.h>
#include <iostream.h>
#include <Instrument.h>
#include <ugens.h>
#include "SNARE.h"
#include <rt.h>

SNARE::SNARE() : Instrument()
{
}

int SNARE::init(float p[], int n_args)
{
	// p0 = start, p[1] = duration, p[2] = amp, p[3] = oscillator
	nsamps = rtsetoutput(p[0], p[1], this);

	amp = p[2];

	theOscil = new Ooscili(p[3], 1); // assumes makegen 1 is a sine wave
	theEnv = new Ooscili(1.0/p[1], 2); // assumes makegen 2 is the "damped"
						// envelope

	return(nsamps);
}

int SNARE::run()
{
	int i;
	float noise;
	float oscilval;
	float out[2];
	float envamp;
	
	Instrument::run();


	for (i = 0; i < chunksamps; i++) {
		// N + T + N*T where N == noise and T == a damped sine wave
		envamp = theEnv->next(); // we damp the noise + oscil by
					// multiplying with this envelope

		noise = rrand() * envamp;

		oscilval = theOscil->next() * envamp;

		// this is the equation...
		out[0] = (noise + oscilval + (noise*oscilval)) * amp;
		out[1] = out[0]; // simple stereo output

		rtaddout(out);

		cursamp++;
	}
	return i;
}

Instrument*
makeSNARE()
{
	SNARE *inst;
	inst = new SNARE();
	inst->set_bus_config("SNARE");
	return inst;
}

void
rtprofile()
{
	RT_INTRO("SNARE",makeSNARE);
}

